<?php
#BEGIN_LICENSE
#-------------------------------------------------------------------------
# Module: MAMS (c) 2020-2021 by CMS Made Simple Foundation
#  An add-on module for CMS Made Simple to provide useful functions
#  and commonly used gui capabilities to other modules.
#-------------------------------------------------------------------------
# A fork of:
#
# Module: FrontEndUsers (c) 2008-2014 by Robert Campbell
#         (calguy1000@cmsmadesimple.org)
#
#-------------------------------------------------------------------------
#
# CMSMS - CMS Made Simple is (c) 2006 - 2021 by CMS Made Simple Foundation
# CMSMS - CMS Made Simple is (c) 2005 by Ted Kulp (wishy@cmsmadesimple.org)
# Visit the CMSMS Homepage at: http://www.cmsmadesimple.org
#
#-------------------------------------------------------------------------
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# However, as a special exception to the GPL, this software is distributed
# as an addon module to CMS Made Simple.  You may not use this software
# in any Non GPL version of CMS Made simple, or in any version of CMS
# Made simple that does not indicate clearly and obviously in its admin
# section that the site was built with CMS Made simple.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
# Or read it online: http://www.gnu.org/licenses/licenses.html#GPL
#
#-------------------------------------------------------------------------
#END_LICENSE

namespace MAMS;
if( !defined('CMS_VERSION') ) { exit; }
if( !$this->_HasSufficientPermissions( 'users' ) ) return;
$this->SetCurrentTab('users');

try {
    $uid = \xt_param::get_int( $params, 'uid' );

    // generate a unique disabled username... something pretty much guaranteed to be unique
    $new_username = 'u'.sha1( time().__FILE__.rand() );
    $new_password = sha1( sha1( time().__FILE__.rand() ) );

    // todo: check if the new username exists

    // send a hook before anonimizing
    \CMSMS\HookManager::do_hook( 'MAMS::BeforeAnonimizeUser', $uid );

    $files = $this->GetUserFilesFull( $uid, TRUE );
    if( $files ) {
        $path = $this->get_upload_dirname();
        foreach( $files as $file ) {
            $fn = "$path/$file";
            $tn = "$path/thumb_{$file}";
            if( is_file($fn) && !is_writable($fn) ) throw new \RuntimeException("Insufficient permission to remove user file $file");
            if( is_file($tn) && !is_writable($tn) ) throw new \RuntimeException("Insufficient permission to remove user thumbnail for $file");
            if( is_file($tn) ) unlink($tn);
            if( is_file($fn) ) unlink($fn);
        }
    }

    // clear all the users properties
    $this->DeleteAllUserPropertiesFull( $uid );

    // we adjust the username, the password, and disable the account
    $this->SetUserDisabled( $uid );
    $this->SetUser( $uid, $new_username, $new_password );

    // delete all user history
    $sql = 'DELETE FROM '.cms_db_prefix().'module_mams_history WHERE userid = ?';
    $db->Execute( $sql, [ $uid ] );

    // send a hook after anonimizing
    \CMSMS\HookManager::do_hook( 'MAMS::AfterAnonimizeUser', $uid );

    audit($uid,'MAMS','User anonimized');

    $this->SetMessage( $this->Lang('msg_anonimized') );
    $this->RedirectToTab();
}
catch( \Exception $e ) {
    $this->SetError($e->GetMessage());
    $this->RedirectToTab();
}
